<template>
    <v-container>
        <v-row class="mt-5">
            <v-col cols="3"></v-col>
            <v-col cols="6" class="d-flex justify-center" >
                <v-img
                    lazy-src="@/assets/logo.png"
                    max-height="250"
                    max-width="250"
                    src="@/assets/logo.png"
                >
                </v-img>
            </v-col>
            <v-col cols="3"></v-col>
            <v-col sm="3" md="3" cols="1"></v-col>
            <v-col sm="6" md="6" cols="10">
                <template v-if="!spinner">
                    <v-card>
                        <v-form
                                ref="form"
                                v-model="valid"
                                lazy-validation
                            >

                        <v-card-text>
                            <v-row>
                                <v-col cols="12">
                                    <v-text-field
                                        label="Usuario"
                                        v-model="formData.user"
                                        :rules="userRules"
                                        :error-messages="errorAuth"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col cols="12" class="pb-0">
                                    <v-text-field
                                        type="password"
                                        label="Password"
                                        v-model="formData.password"
                                        :rules="passwordRules"
                                        :error-messages="errorAuth"
                                    ></v-text-field>
                                </v-col>
                            </v-row>
                            <!-- <v-row>
                                <v-col cols="12" class="mt-0 mb-0 pb-0">
                                    <v-checkbox
                                        label="Remenber Me"
                                    ></v-checkbox>
                                </v-col>
                            </v-row> -->
                        </v-card-text>
                        <v-card-actions>
                            <v-row class="mb-3">
                                <v-col cols="6" class="d-flex align-center">
                                    <!-- <v-btn 
                                        x-small 
                                        text
                                    >
                                        Recuperar contraseña
                                    </v-btn> -->
                                    
                                </v-col>

                                <v-col cols="5" class="d-flex justify-end">
                                    <v-btn
                                        color="deep-purple lighten-2"
                                        text
                                        @click="login()"
                                        :disabled="!valid"
                                    >
                                        Entrar
                                    </v-btn>
                                </v-col>

                                <v-col cols="1">
    
                                </v-col>
                            </v-row>
                        </v-card-actions>

                        </v-form>
                    </v-card>
                </template>
                <template v-else>
                    <div class="d-flex justify-center">
                        <v-progress-circular
                            :size="100"
                            color="primary"
                            indeterminate
                        ></v-progress-circular>
                    </div>
                </template>
            </v-col>
            <v-col sm="3" md="3" cols="1"></v-col>
        </v-row>
    </v-container>
</template>

<script setup>
    import { reactive, ref, watchEffect  } from 'vue';
    import store from '@/store';
    import { HttpReq } from "@/utilies/httpRequest";

    const valid = ref(true)
    const form = ref(null)
    const errorAuth = ref("")
    const userRules = ref([
        v => !!v || 'Nombre es requerido',
        v => (v && v.length >= 5) || 'El usuario debe terner al menos 5 caracteres'
    ]);
    const passwordRules = ref([
        v => !!v || 'Mombre es requerido',
        v => (v && v.length >= 5) || 'La contraseña debe terner al menos 5 caracteres'
    ])
    const formData = reactive({
        user: "",
        password: ""
    })
    const spinner = ref(false)

    watchEffect(() => {
        if( ( formData.user != '' || formData.password != '' ) && errorAuth.value != "" ) {
            errorAuth.value = ""
        }
    })

    async function login() {

        /* eslint-disable */
        if(!form.value.validate())
            return

        spinner.value = true

        let uri = `username=${formData.user}&password=${formData.password}`
        let resp = await HttpReq.getData('login', uri)
        setTimeout(function() {
            spinner.value = false
            formData.password = ""
            formData.user = ""
            if(resp.status == 200) {
                if(resp.data) {
                    store.dispatch('saveSession', resp.data.access_token)
                }
            } else {
                errorAuth.value = "Usuario ó contraseña invalidos";
                store.state.refModalNotification = true
            }
        }, 1000);
        /* eslint-disable */
    }

</script>

<style>

</style>